/*
 * ar5315.c - AR2315/AR2316/AR2317/AR2318 specific system functions 
 *
 * copyright 2009 Sebastian Gottschall / NewMedia-NET GmbH / DD-WRT.COM
 * licensed under GPL conditions
 */
#include "mips32.c"
#include "spiflash.h"

/* definition of basic flash mappings */
static unsigned int sectorsize = 0x10000;
static unsigned int linuxaddr = 0xbf010000;
static unsigned int flashbase = 0xbf000000;
static unsigned int flashsize = 0x800000;

#define disable_watchdog() \
{ 					\
}					\

static int getGPIO(int nr)
{
	volatile unsigned int *gpio = (unsigned int *)AR7100_GPIO_IN;
	if ((*gpio & 1 << nr) == (1 << nr))
		return 1;
	return 0;
}

#define ag7100_reset_mask(_no) (_no) ? (AR7100_RESET_GE1_MAC |  \
                                        AR7100_RESET_GE1_PHY)   \
                                     : (AR7100_RESET_GE0_MAC |  \
                                        AR7100_RESET_GE0_PHY)

static void enable_ethernet(void)
{
	unsigned int mask = ag7100_reset_mask(0);
	/*
	 * put into reset, hold, pull out.
	 */
	ar7100_reg_rmw_set(AR7100_RESET, mask);
	udelay(1000 * 1000);
	ar7100_reg_rmw_clear(AR7100_RESET, mask);
	udelay(1000 * 1000);
	udelay(20);
}

static const char *get_system_type(void)
{
	char *chip;
	u32 id;
	u32 rev;
	id = ar7100_reg_rd(AR7100_REV_ID) & AR7100_REV_ID_MASK;
	rev = (id >> REV_ID_REVISION_SHIFT) & REV_ID_REVISION_MASK;
	switch (id & AR7100_REV_ID_CHIP_MASK) {
	case AR7100_REV_ID_AR7130:
		chip = "7130";
		break;
	case AR7100_REV_ID_AR7141:
		chip = "7141";
		break;
	case AR7100_REV_ID_AR7161:
		chip = "7161";
		break;
	case AR7100_REV_ID_AR9130:
		chip = "9130";
		break;
	case AR7100_REV_ID_AR9132:
		chip = "9132";
		break;
	case AR7240_REV_1_0:
	case AR7240_REV_1_1:
	case AR7240_REV_1_2:
		chip = "7240";
		break;
	default:
		chip = "71xx";
	}
	return chip;
}
